zoukankan      html  css  js  c++  java
  • POJ 3734 Blocks

    http://poj.org/problem?id=3734

    Description

    Panda has received an assignment of painting a line of blocks. Since Panda is such an intelligent boy, he starts to think of a math problem of painting. Suppose there are N blocks in a line and each block can be paint red, blue, green or yellow. For some myterious reasons, Panda want both the number of red blocks and green blocks to be even numbers. Under such conditions, Panda wants to know the number of different ways to paint these blocks.

    Input

    The first line of the input contains an integer T(1≤T≤100), the number of test cases. Each of the next T lines contains an integer N(1≤N≤10^9) indicating the number of blocks.

    Output

    For each test cases, output the number of ways to paint the blocks in a single line. Since the answer may be quite large, you have to module it by 10007.

    Sample Input

    2
    1
    2

    Sample Output

    2
    6

    题解:矩阵快速幂

    代码:

    #include <iostream>
    #include <algorithm>
    #include <math.h>
    #include <vector>
    #include <stdio.h>
    using namespace std;
    
    typedef long long ll;
    
    typedef vector<ll> vec;
    typedef vector<vec> mat;
    
    const int M = 10007;
    int T, N;
    
    mat mul(mat& A, mat& B) {
        mat C(A.size(), vec(B[0].size()));
        for ( int i = 0 ; i < A.size() ;i ++) {
            for ( int k = 0 ; k < B.size() ; k ++) {
                for ( int j = 0 ; j < B[0].size() ; j ++) {
                    C[i][j] = (C[i][j] + A[i][k] * B[k][j] % M) % M;
                }
            }
        }
        return C;
    }
    
    mat pow(mat A, ll n) {
        mat B(A.size(), vec(A.size()));
        for ( int i = 0 ; i < A.size() ; i ++) {
            B[i][i] = 1;
        }
        while ( n > 0 ) {
            if ( n & 1 ) B = mul(B, A);
            A = mul(A, A);
            n >>= 1;
        }
        return B;
    }
    
    void solve() {
        mat A(3, vec(3));
        A[0][0] = 2; A[0][1] = 1; A[0][2] = 0;
        A[1][0] = 2; A[1][1] = 2; A[1][2] = 2;
        A[2][0] = 0; A[2][1] = 1; A[2][2] = 2;
        A = pow(A, N);
        printf("%d
    ", A[0][0]);
    }
    
    int main() {
        scanf("%d", &T);
        while(T --) {
            scanf("%d", &N);
            solve();
        }
        return 0;
    }
    

      

  • 相关阅读:
    [洛谷P2742]【模板】二维凸包([USACO5.1]圈奶牛Fencing the Cows)
    [洛谷P4781]【模板】拉格朗日插值
    [洛谷P4550]收集邮票
    [洛谷P4900]食堂
    [洛谷P2057][SHOI2007]善意的投票
    [CF1083C]Max Mex
    bzoj3110: [Zjoi2013]K大数查询 【树套树,标记永久化】
    bzoj 1207: [HNOI2004]打鼹鼠 (dp)
    bzoj 1037: [ZJOI2008]生日聚会Party (dp)
    bzoj 2140: 稳定婚姻 (二分图)
  • 原文地址:https://www.cnblogs.com/zlrrrr/p/9879187.html
Copyright © 2011-2022 走看看